
#pragma once

/*
 *	Don't set this high at beginning
 */
#define MAX_FASTOPEN_SOCK 2048

#include <sys/types.h>

static const char* kFASTOPEN_SERV_PATH = "/tmp/fastopen_daemon";

enum {
	FASTOPEN_SOCK_INVALID,
	FASTOPEN_SOCK_IDLE,
	FASTOPEN_SOCK_CONNECTING,
	FASTOPEN_SOCK_CONNECTED
};

/*
 *	Use -1 to represent request to add a socket
 */
#define FASTOPEN_NEW_SOCK -1

enum {
	FASTOPEN_ADD_PROC,
	FASTOPEN_DEL_PROC,
	FASTOPEN_DUP_PROC,
	FASTOPEN_ADD_SOCK,
	FASTOPEN_DEL_SOCK,
	FASTOPEN_WAIT_SOCK_STATE,
	FASTOPEN_GET_SOCK_STATE,
	FASTOPEN_SET_SOCK_STATE,
	FASTOPEN_CMP_SET_SOCK_STATE,
	//
	//	These are only for debugging
	//
	FASTOPEN_DEBUG_PROC_LIST,
	FASTOPEN_DEBUG_SOCK_LIST
};


struct FASTOPENCmd {
	int op;
	int gsockfd;
	int state;
	int cmp_state;
	pid_t pid1;
	pid_t pid2;
};

struct FASTOPENRet {
	int should_ret;
	int is_valid;
	int state;
};
