
#include "fastopen_kernel_def.h"

#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <unistd.h>
#include <stdio.h>
#include <assert.h>
#include <string.h>
#include <errno.h>

#include "tst.h"

static char *msg_pref_client = "client-pref";
static char *msg_pref_server = "server-repl";

static int work_client(int fd)
{
	char buf[100];
	printf("her\n");
	
	assert(stable_send(fd, msg_pref_client, strlen(msg_pref_client) + 1)
			== strlen(msg_pref_client) + 1);
	if (stable_recv(fd, buf, strlen(msg_pref_server) + 1) >= 0) {
printf("?");
		assert(strcmp(msg_pref_server, buf) == 0);
		int i = 0;
		for (i = 0; i < 1000; i++) {
			char buf_ans[100];
			sprintf(buf, "client-tst-%d", i);
			if (stable_send(fd, buf, strlen(buf) + 1) < 0) {
				printf("error in sending %d\n", i);
				break;
			}
			printf("send %d\n", i);
			sprintf(buf_ans, "server-tst-%d", i);
			if (stable_recv(fd, buf, strlen(buf_ans) + 1) < 0) {
				printf("error in receiving %d\n", i);
				break;
			}
			assert(strcmp(buf_ans, buf) == 0);
			printf("recv %d\n", i);
		}
	} else {
		printf("receive error");
	}
	close(fd);
	return 0;
}

static int work_server(int serv)
{
	int fastopen_type = 1;
	assert(setsockopt(serv, IPPROTO_TCP, TCP_FASTOPEN, &fastopen_type, sizeof(int))
	       == 0);
printf("??\n");
	char data[1024];

	assert(stable_recv(serv, data, strlen(msg_pref_client) + 1) == 
			strlen(msg_pref_client) + 1);

	assert(strcmp(msg_pref_client,  data) == 0);

	if (stable_send(serv, msg_pref_server, strlen(msg_pref_server) + 1) >=
	    0) {
		int i = 0;
		printf("entering sending process\n");
		for (i = 0; i < 1000; i++) {
			char buf[100];
			char buf_ans[100];
			sprintf(buf_ans, "client-tst-%d", i);
			if (stable_recv(serv, buf, strlen(buf_ans) + 1) < 0) {
				printf("error in receiving\n");
				abort();
			}
			printf("recv %d\n", i);
			assert(strcmp(buf_ans, buf) == 0);
			sprintf(buf, "server-tst-%d", i);
			if (stable_send(serv, buf, strlen(buf) + 1) < 0) {
				printf("error in sending\n");
				abort();
			}
			printf("send %d\n", i);
		}
		printf("test passed\n");
	}
	close(serv);
	return 0;
}

int main(int argc, char **argv)
{
	if (argc > 1 && argv[1][0] == 'c') {
		int cli = create_std_client("192.168.56.101");
		work_client(cli);
	} else {
		int ser = create_std_server();
printf("??\n");
		server_loop(ser, work_server);
	}
	return 0;
}
